import { Map, OrderedSet } from "immutable";
import { Type, NamedType, ClassType, UnionType } from "./Type";
import { Namespace, Name, Namer, DependencyName } from "./Naming";
import { Renderer, BlankLineLocations } from "./Renderer";
export declare abstract class ConvenienceRenderer extends Renderer {
    private _globalNamespace;
    private _topLevelNames;
    private _classAndUnionNames;
    private _propertyNames;
    private _namedClasses;
    private _namedUnions;
    protected readonly forbiddenNames: string[];
    protected topLevelDependencyNames(topLevelName: Name): DependencyName[];
    protected abstract topLevelNameStyle(rawName: string): string;
    protected abstract namedTypeNameStyle(rawName: string): string;
    protected abstract propertyNameStyle(rawName: string): string;
    protected abstract namedTypeToNameForTopLevel(type: Type): NamedType | null;
    protected readonly abstract namedTypeNamer: Namer;
    protected readonly abstract propertyNamer: Namer;
    protected abstract emitSourceStructure(): void;
    protected unionNeedsName(u: UnionType): boolean;
    protected setUpNaming(): Namespace[];
    private nameForTopLevel;
    private addClassOrUnionNamed;
    private addPropertyNameds;
    private childrenOfType;
    protected readonly namedUnions: OrderedSet<UnionType>;
    protected readonly haveUnions: boolean;
    protected unionFieldName: (t: Type) => string;
    protected nameForNamedType: (t: NamedType) => Name;
    protected forEachTopLevel: (blankLocations: BlankLineLocations, f: (t: Type, name: Name) => void) => void;
    protected forEachClass: (blankLocations: BlankLineLocations, f: (c: ClassType, className: Name, propertyNames: Map<string, Name>) => void) => void;
    protected forEachUnion: (blankLocations: BlankLineLocations, f: (u: UnionType, unionName: Name) => void) => void;
    protected emitSource(): void;
}
